local L = LibStub("AceLocale-3.0"):GetLocale("NeedjaTrackerPlus", true)

function NTP:Options()
    if not self.options then
        self.options = {
            type = "group",
            args = {
                general = {
                    type = "group",
                    name = L.title,
                    args = {
                        enable = {
                            type = "toggle",
                            name = L.cfg_enable,
                            order = 10,
                            width = "full",
                            get = function()
                                return self:GetProfileValue('enable')
                            end,
                            set = function(_, value)
                                self:SetProfileValue('enable', value)
                                self:ProcessConfigUpdate()
                            end,
                        },
                        chat_options = {
                            type = "header",
                            name = L.cfg_chat_options,
                            order = 20,
                        },
                        need_warning_party = {
                            type = "description",
                            name = L.cfg_need_warning,
                            order = 30,
                        },
                        in_party = {
                            type = "select",
                            name = L.cfg_in_party,
                            order = 40,
                            values = { L.cfg_never, L.cfg_leader, L.cfg_always },
                            get = function()
                                return self:GetProfileValue('warn_party')
                            end,
                            set = function(_, value)
                                self:SetProfileValue('warn_party', value)
                            end,
                        },
                        in_lfg_party = {
                            type = "select",
                            name = L.cfg_in_lfg_party,
                            order = 50,
                            values = { L.cfg_never, L.cfg_leader, L.cfg_always },
                            get = function()
                                return self:GetProfileValue('warn_lfg_party')
                            end,
                            set = function(_, value)
                                self:SetProfileValue('warn_lfg_party', value)
                            end,
                        },
                        need_warning_raid = {
                            type = "description",
                            name = "",
                            order = 60,
                        },
                        in_raid = {
                            type = "select",
                            name = L.cfg_in_raid,
                            order = 70,
                            values = { L.cfg_never, L.cfg_leader, L.cfg_leader_and_assist, L.cfg_always },
                            get = function()
                                return self:GetProfileValue('warn_raid')
                            end,
                            set = function(_, value)
                                self:SetProfileValue('warn_raid', value)
                            end,
                        },
                        in_lfr_raid = {
                            type = "select",
                            name = L.cfg_in_lfr_raid,
                            order = 80,
                            values = { L.cfg_never, L.cfg_leader, L.cfg_leader_and_assist, L.cfg_always },
                            get = function()
                                return self:GetProfileValue('warn_lfr_raid')
                            end,
                            set = function(_, value)
                                self:SetProfileValue('warn_lfr_raid', value)
                            end,
                        },
                    }
                },
            }
        }
        self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
    end
    return self.options
end

function NTP:Defaults()
    if not self.defaults then
        self.defaults = {
            profile = {
                enable = true,

                warn_party = 1,
                warn_lfg_party = 1,
                warn_raid = 1,
                warn_lfr_raid = 1,
            },
            char = {
                history = {},
                stat = {},
                current = {},
            },
        }
    end
    return self.defaults
end
